package djmil.hellomvc;

import java.security.Principal;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
public class GreetingController {

    private final GreetingService greetigService;

	public GreetingController(GreetingService greetigService) {
		this.greetigService = greetigService;
	}

	@GetMapping("/greeting")
	public String greeting(@RequestParam(name="name", required=false, defaultValue="World") String name, Model model) {
        
        model.addAttribute("name", name);
        model.addAttribute("nameLength", greetigService.nameLength(name));
        // NOTE: Here we can request some data from our RESTful backend as well

        return "greeting"; // view tempalte
    }

    @GetMapping("/login")
    String login() {
        return "login";
    }

    @GetMapping("/secret")
    public String secret(Principal principal, Model model) {

        model.addAttribute("name", principal.getName());
        model.addAttribute("secret", 42);

        return "secret";
    }

}